%Works out local asymptotic RMSE
%Version of Oosla that omits Laplace and LASSO
%Output is 11x1 consisting of:
%OLS/JS/AIC/OOS/SS/JSB/AICB/OOSB/SSB/OOSRB/SSRB
%Model=1: Consider all permutations
%Model=2: Consider ordered models
function stat = oosla0(b,pi);
randn('seed',123);
model=2;    
K=length(b);
n=1000;
n=round(round(n*min(pi,1-pi))/min(pi,1-pi));
npi=n*pi;
L=round(1/min(pi,1-pi));
replics=1000;
%imat=ones(K,1)*ones(1,K);     %Conditional on vector of 1s
imat=eye(K);                   %Unconditional
nba=50;
rvec=[1/n:1/n:1]';
for imc=1:replics;
    B1=randn(K,1);
    capy=b'+B1';
    ub=cumsum(randn(n,K)/sqrt(n));
    ub=ub-(rvec*ub(n,:));
    y=(rvec*capy)+ub;
    indx=1;
    v(:,indx)=zeros(K,1); aic(indx,1)=0;
    for j=1:K;
        if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;
        for i=1:size(a,1);
            indx=indx+1;
            c1=a(i,:);
            yz=zeros(K,1); yz(c1)=y(n,c1)';
            v(:,indx)=yz;
            aic(indx,1)=(yz'*yz)-(2*j);
        end;
    end;
    [qw1,qw2]=max(aic);
    u(imc,1)=(v(:,end)-b)'*imat*(v(:,end)-b);
    if K<=2; 
        u(imc,2)=u(imc,1);
    else;
        jsb=v(:,end)*max(0,1-((K-2)/(v(:,end)'*v(:,end))));
        u(imc,2)=(jsb-b)'*imat*(jsb-b);
    end;
    u(imc,3)=(v(:,qw2)-b)'*imat*(v(:,qw2)-b);    
    clear v aic
%-----------------------------------------%    
    indx=1;
    v(:,indx)=zeros(K,1); s(indx,1)=0; 
    for j=1:K;
        if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;
        for i=1:size(a,1);
            indx=indx+1;
            yz=zeros(K,1); yzpi=zeros(K,1); yz(a(i,:))=y(n,a(i,:))'; yzpi(a(i,:))=y(npi,a(i,:))';
            v(:,indx)=yz;
            s(indx,1)=(yz'*yz)-(yzpi'*yzpi/pi)+(j*log(pi));
        end;
    end;
    [qw1,qw2]=max(s);
    u(imc,4)=(v(:,qw2)-b)'*imat*(v(:,qw2)-b);
    clear v s
 %-----------------------------------------%    
    indx=1;
    v(:,indx)=zeros(K,1); aic(indx,1)=0;
    for j=1:K;
        if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;
        for i=1:size(a,1);
            indx=indx+1;
            c1=a(i,:); 
            yz=zeros(K,1); yz(c1)=y(npi,c1)';
            yzz=zeros(K,1); yzz(c1)=(y(n,c1)-y(npi,c1))'/(1-pi);           
            v(:,indx)=yzz;
            aic(indx,1)=(yz'*yz/pi)-(2*j);
       end;
    end;
    [qw1,qw2]=max(aic);
    u(imc,5)=(v(:,qw2)-b)'*imat*(v(:,qw2)-b);
    clear v aic
%---------------------------------------------%    
    for jmc=1:nba;
        wba=cumsum(randn(n,K)/sqrt(n));
        y=(rvec*capy)+wba;
        indx=1;
        v(:,indx)=zeros(K,1); aic(indx,1)=0;
        for j=1:K;
            if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;
            for i=1:size(a,1);
                indx=indx+1;
                c1=a(i,:); 
                yz=zeros(K,1); yz(c1)=y(n,c1)';
                v(:,indx)=yz;
                aic(indx,1)=(yz'*yz)-(2*j);
            end;
        end;
        [qw1,qw2]=max(aic);
        if K>2;
            uba1(:,jmc)=v(:,end)*max(0,1-((K-2)/(v(:,end)'*v(:,end))));
        end;
        uba2(:,jmc)=v(:,qw2);
        clear v aic;
%-----------------------------------------%    
        indx=1;
        v(:,indx)=zeros(K,1); s(indx,1)=0; 
        for j=1:K;
            if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;
            for i=1:size(a,1);
                indx=indx+1;
                yz=zeros(K,1); yzpi=zeros(K,1); yz(a(i,:))=y(n,a(i,:))'; yzpi(a(i,:))=y(npi,a(i,:))';
                v(:,indx)=yz;
                s(indx,1)=(yz'*yz)-(yzpi'*yzpi/pi)+(j*log(pi));
            end;
        end;
        [qw1,qw2]=max(s);
        uba3(:,jmc)=v(:,qw2);
        clear v s
%-----------------------------------------%    
        indx=1;
        v(:,indx)=zeros(K,1); aic(indx,1)=0;
        for j=1:K;
            if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;
            for i=1:size(a,1);
                indx=indx+1;
                c1=a(i,:); 
                yz=zeros(K,1); yz(c1)=y(npi,c1)';
                yzz=zeros(K,1); yzz(c1)=(y(n,c1)-y(npi,c1))'/(1-pi);           
                v(:,indx)=yzz;
                aic(indx,1)=(yz'*yz/pi)-(2*j);
            end;
        end;
        [qw1,qw2]=max(aic);
        uba4(:,jmc)=v(:,qw2);
        clear v aic
%-----------------------------------------%    
        ub=cumsum(randn(n,K)/sqrt(n));
        ub=ub-(rvec*ub(n,:));
        y=(rvec*capy)+ub;
%-----------------------------------------%
        indx=1;
        v(:,indx)=zeros(K,1); s(indx,1)=0; 
        for j=1:K;
            if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;
            for i=1:size(a,1);
                indx=indx+1;
                yz=zeros(K,1); yzpi=zeros(K,1); yz(a(i,:))=y(n,a(i,:))'; yzpi(a(i,:))=y(npi,a(i,:))';
                v(:,indx)=yz;
                s(indx,1)=(yz'*yz)-(yzpi'*yzpi/pi)+(j*log(pi));
            end;
        end;
        [qw1,qw2]=max(s);
        uba5(:,jmc)=v(:,qw2);
        clear v s
%-----------------------------------------%
        indx=1;
        v(:,indx)=zeros(K,1); aic(indx,1)=0;
        for j=1:K;
            if model==2; a=[1:1:j]; else; a=nchoosek([1:1:K],j); end;
            for i=1:size(a,1);
                indx=indx+1;
                c1=a(i,:); 
                yz=zeros(K,1); yz(c1)=y(npi,c1)';
                yzz=zeros(K,1); yzz(c1)=(y(n,c1)-y(npi,c1))'/(1-pi);           
                v(:,indx)=yzz;
                aic(indx,1)=(yz'*yz/pi)-(2*j);
            end;
        end;
        [qw1,qw2]=max(aic);
        uba6(:,jmc)=v(:,qw2);
        clear v aic
    end;
    if K<=2; 
        u(imc,6)=u(imc,1);
    else;
        u(imc,6)=(mean(uba1')'-b)'*imat*(mean(uba1')'-b);
    end;
    u(imc,7)=(mean(uba2')'-b)'*imat*(mean(uba2')'-b);
    u(imc,8)=(mean(uba3')'-b)'*imat*(mean(uba3')'-b);
    u(imc,9)=(mean(uba4')'-b)'*imat*(mean(uba4')'-b);
    u(imc,10)=(mean(uba5')'-b)'*imat*(mean(uba5')'-b);
    u(imc,11)=(mean(uba6')'-b)'*imat*(mean(uba6')'-b);
end;
stat=sqrt(mean(u));
